/* Test showing how you can return values from thread using join */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

#define NUM_THREADS	10

void *print_message(void *threadid) {

	long int tid;
	tid = (long int)threadid;

	printf("\tIn thread #%ld, returning value %ld!\n", tid,tid*2);

	pthread_exit( (void *)(tid*2));
}

int main (int argc, char **argv) {

	pthread_t threads[NUM_THREADS];
	int result;
	long int t;	/* long int as we cast to a void */

	for(t=0; t<NUM_THREADS; t++) {
		printf("Creating thread %ld\n", t);
		result = pthread_create(
					&threads[t],
					NULL,
					print_message,
					(void *)t);

		if (result) {
			fprintf(stderr,"ERROR: pthread_create returned %d\n",
					result);
			exit(-1);
		}
	}

	void *return_val;

	for(t=0; t<NUM_THREADS; t++) {
		result = pthread_join(threads[t],&return_val);

		printf("Joined thread %ld result=%d return value=%ld\n",
			 t,result,(long)return_val);

	}
	pthread_exit(NULL);
}
